declare global {
  namespace NodeJS {
    interface ProcessEnv {
      NODE_ENV: "development" | "production";
      PORT: string;

      /**
       * Publicly accessable hostname
       */
      HOST: string;

      /**
       * [development] SSL port
       * Matrix federation requires SSL
       */
      DEV_SSL_PORT?: string;
      /**
       * [development] SSL key path
       * Path to self-signed key
       */
      DEV_SSL_KEY_PATH?: string;
      /**
       * [development] SSL certificate path
       * Path to self-signed cert
       */
      DEV_SSL_CERT_PATH?: string;

      /**
       * Outgoing token (-> matrix)
       */
      MATRIX_AS_TOKEN: string;
      /**
       * What AS identifier we're registered as
       */
      MATRIX_AS_ID: string;
      /**
       * Incoming token (-> express)
       */
      MATRIX_HS_TOKEN: string;
      /**
       * Way to connect to homeserver
       */
      MATRIX_HOMESERVER: string;
      /**
       * Hostname that should be used instead of MATRIX_HOMESERVER
       * @example `localhost` when MATRIX_HOMESERVER is `localhost:8008`
       */
      MATRIX_HOMESERVER_HOST?: string;
      DISCORD_TOKEN: string;

      /**
       * what matrix account is able to invite the main bot
       * @example @grant:aftermath.gg
       */
      MATRIX_ADMIN: string;

      VOID_ALL_TRANSACTIONS: string;
    }
  }
}

export {};
